.586
.model flat,stdcall
option casemap:none

include \Projects\GdipTest\GdipTest.inc


WinMain proto :DWORD,:DWORD,:DWORD,:DWORD


.data
   ClassName 	db "MainWinClass",0
   AppName  	db "Main Window",0
   _szText		db "Gdi+ testing bla bla...",0

.data?
   hInstance HINSTANCE ?
   CommandLine LPSTR ?
   hMainMenu DD ?

.code


; ---------------------------------------------------------------------------


start:
	invoke GetModuleHandle, NULL
	mov    hInstance,eax
	
	invoke GetCommandLine
	mov    CommandLine,eax
	
	invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT
	invoke ExitProcess,eax

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	LOCAL hwnd:HWND
	
	mov   wc.cbSize,SIZEOF WNDCLASSEX
	mov   wc.style, CS_HREDRAW or CS_VREDRAW
	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra,NULL
	mov   wc.cbWndExtra,NULL
	push  hInstance
	pop   wc.hInstance
	mov   wc.hbrBackground,COLOR_BTNTEXT+1
	mov   wc.lpszMenuName,NULL
	mov   wc.lpszClassName,OFFSET ClassName
	
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov   wc.hIcon,eax
	mov   wc.hIconSm,eax
	
	invoke LoadCursor,NULL,IDC_ARROW
	mov   wc.hCursor,eax
	
	invoke RegisterClassEx, addr wc
	INVOKE CreateWindowEx,NULL,ADDR ClassName,ADDR AppName,\
           WS_OVERLAPPEDWINDOW,CW_USEDEFAULT,\
           CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,NULL,NULL,\
           hInst,NULL
	mov   hwnd,eax
	
	invoke ShowWindow, hwnd,SW_SHOWNORMAL
	invoke UpdateWindow, hwnd
	
	.WHILE TRUE
		invoke GetMessage, ADDR msg,NULL,0,0
		.BREAK .IF (!eax)
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage, ADDR msg
	.ENDW
	
	mov     eax,msg.wParam
	ret
WinMain endp

WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

	LOCAL @gdiplusstartupinput	:GdiplusStartupInput
	LOCAL @pbuffer				:DWORD
	LOCAL @rect					:RECT
	LOCAL @rectf				:GDIPLUSRECTF
	LOCAL @rectf1				:GDIPLUSRECTF
	LOCAL @rectf2				:GDIPLUSRECTF
	LOCAL @rectfs[2]			:DWORD
	LOCAL @x1,@y1,@x2,@y2		:DWORD
	LOCAL @alpha				:DWORD
	LOCAL @red					:DWORD
	LOCAL @green				:DWORD
	LOCAL @blue					:DWORD
	LOCAL @hdc					:DWORD

	.IF uMsg==WM_DESTROY
		invoke TerminateGdiPlus
		invoke PostQuitMessage,NULL
	
	.ELSEIF uMsg==WM_CREATE
		invoke	RtlZeroMemory, addr @gdiplusstartupinput, sizeof GdiplusStartupInput
		mov		@gdiplusstartupinput.GdiplusVersion, 1
		
		invoke GdiplusStartup, addr _pGdiPlusToken, addr @gdiplusstartupinput, NULL
		;load main menu
		invoke LoadMenu, hInstance, IDR_MENU
		.if eax != NULL
			mov hMainMenu, eax
			invoke SetMenu, hWnd, eax
		.endif
		
		MAKEWPARAM IDM_newgdipobjs,0
		invoke PostMessage,hWnd,WM_COMMAND,eax,0
		
	.ELSEIF uMsg == WM_COMMAND
	   .if	lParam == 0
	   		;menu command
			mov eax,wParam
			and eax, 0FFFFh
			
			.if eax == IDM_exit
				invoke SendMessage,hWnd,WM_CLOSE,NULL,NULL
			
			.ELSEIF eax == IDM_newgdipobjs
				MAKEWPARAM IDM_newgraphics,0
				invoke PostMessage,hWnd,WM_COMMAND,eax,0
				MAKEWPARAM IDM_newfontfamily,0
				invoke PostMessage,hWnd,WM_COMMAND,eax,0
				MAKEWPARAM IDM_newfont,0
				invoke PostMessage,hWnd,WM_COMMAND,eax,0
				MAKEWPARAM IDM_newbrush,0
				invoke PostMessage,hWnd,WM_COMMAND,eax,0
				MAKEWPARAM IDM_newpen,0
				invoke PostMessage,hWnd,WM_COMMAND,eax,0
				MAKEWPARAM IDM_newstrformat,0
				invoke PostMessage,hWnd,WM_COMMAND,eax,0
				
			.ELSEIF EAX == IDM_newgraphics
				.if _hGdiPlusGraphics == NULL
					invoke GdipCreateFromHWND,hWnd,addr _hGdiPlusGraphics
				.endif
				
			.elseif eax == IDM_newfontfamily
				.if _hGdiPlusFontFamily == NULL
					invoke AnsiToWChar,addr _szGdiPlusFontFamilyName,-1
					mov @pbuffer,eax
					invoke GdipCreateFontFamilyFromName,@pbuffer,NULL,addr _hGdiPlusFontFamily
					invoke GlobalFree,@pbuffer
					mov @pbuffer,NULL
				.endif
				
			.elseif eax == IDM_newfont
				.if _hGdiPlusFont == NULL
					.if _hGdiPlusFontFamily != NULL
						invoke GdipCreateFont,_hGdiPlusFontFamily,16,FontStyleRegular,UnitPoint,addr _hGdiPlusFont
					.endif
				.endif
				
			.elseif eax == IDM_newbrush
				.if _hGdiPlusSolidBrush == NULL
					invoke MakeARGB,0FFh,128,128,128
					invoke GdipCreateSolidFill,eax,addr _hGdiPlusSolidBrush
				.endif
				
			.elseif eax == IDM_newpen
				.if _hGdiPlusPen == NULL
					.if _hGdiPlusSolidBrush != NULL
						invoke GdipCreatePen2,_hGdiPlusSolidBrush,1,UnitPixel,addr _hGdiPlusPen
					.endif
				.endif
				
			.elseif eax == IDM_newstrformat
				.if _hGdiPlusStringFormat == NULL
					invoke GdipCreateStringFormat,StringFormatFlagsDirectionRightToLeft,LANG_NEUTRAL,addr _hGdiPlusStringFormat
				.endif
				
			.elseif eax == IDM_delgdipobjs
				MAKEWPARAM IDM_delgraphics,0
				invoke PostMessage,hWnd,WM_COMMAND,eax,0
				MAKEWPARAM IDM_delfontfamily,0
				invoke PostMessage,hWnd,WM_COMMAND,eax,0
				MAKEWPARAM IDM_delfont,0
				invoke PostMessage,hWnd,WM_COMMAND,eax,0
				MAKEWPARAM IDM_delbrush,0
				invoke PostMessage,hWnd,WM_COMMAND,eax,0
				MAKEWPARAM IDM_delpen,0
				invoke PostMessage,hWnd,WM_COMMAND,eax,0
				MAKEWPARAM IDM_delstrformat,0
				invoke PostMessage,hWnd,WM_COMMAND,eax,0
				
			.elseif eax == IDM_delgraphics
				.if _hGdiPlusGraphics != NULL
					invoke GdipDeleteGraphics,_hGdiPlusGraphics
					mov _hGdiPlusGraphics,NULL
				.endif

			.elseif eax == IDM_delfontfamily
				.if _hGdiPlusFontFamily != NULL
					invoke GdipDeleteFontFamily,_hGdiPlusFontFamily
					mov _hGdiPlusFontFamily,NULL
				.endif

			.elseif eax == IDM_delfont
				.if _hGdiPlusFont != NULL
					invoke GdipDeleteFont,_hGdiPlusFont
					mov _hGdiPlusFont,NULL
				.endif

			.elseif eax == IDM_delbrush
				.if _hGdiPlusSolidBrush != NULL
					invoke GdipDeleteBrush,_hGdiPlusSolidBrush
					mov _hGdiPlusSolidBrush,NULL
				.endif

			.elseif eax == IDM_delpen
				.if _hGdiPlusPen != NULL
					invoke GdipDeletePen,_hGdiPlusPen
					mov _hGdiPlusPen,NULL
				.endif
			
			.elseif eax == IDM_delstrformat			
				.if _hGdiPlusStringFormat != NULL
					invoke GdipDeleteStringFormat,_hGdiPlusStringFormat
					mov _hGdiPlusStringFormat,NULL
				.endif
				
			.elseif eax == IDM_drawstring
;				invoke AnsiToWChar,addr _szText,-1
;				mov @pbuffer,eax
				invoke MultiByteToWideChar,CP_OEMCP,MB_PRECOMPOSED,addr _szText,-1,NULL,0
				push eax
				inc eax
				shl eax,1
				invoke GlobalAlloc,GPTR,eax
				mov @pbuffer,eax
				pop eax
				invoke MultiByteToWideChar,CP_OEMCP,MB_PRECOMPOSED,addr _szText,-1,@pbuffer,eax
				FLD4 10.0
				FSTP @rectf.X
				FLD4 10.0
				FSTP @rectf.Y
				FLD4 50.0
				FSTP @rectf.W
				FLD4 20.0
				FSTP @rectf.H
				invoke GdipDrawString,_hGdiPlusGraphics,@pbuffer,-1,_hGdiPlusFont,addr @rectf,_hGdiPlusStringFormat,_hGdiPlusSolidBrush
				PrintHex eax
				invoke FormatGdiPlusErrorMsg,eax
				invoke GlobalFree,@pbuffer
				mov @pbuffer,NULL
			
			.elseif eax == IDM_drawline
				invoke GetDC,hWnd
				mov @hdc,eax
				invoke GetClientRect,hWnd,addr @rect
				m2m @x1,@rect.left
				m2m @y1,@rect.top
				m2m @x2,@rect.right
				m2m @y2,@rect.bottom
				mov @alpha,0FFh
				mov @red,0FFh
				mov @green,0FFh
				mov @blue,0FFh
				.if _hGdiPlusSolidBrush != NULL
					invoke GdipDeleteBrush,_hGdiPlusSolidBrush
					mov _hGdiPlusSolidBrush,NULL
				.endif
				invoke MakeARGB,@alpha,@red,@green,@blue
				invoke GdipCreateSolidFill,eax,addr _hGdiPlusSolidBrush
				.if _hGdiPlusPen != NULL
					invoke GdipDeletePen,_hGdiPlusPen
					mov _hGdiPlusPen,NULL
				.endif
				;-------------------------------------------------------
				.if _hGdiPlusSolidBrush != NULL
					invoke GdipCreatePen2,_hGdiPlusSolidBrush,1,UnitPixel,addr _hGdiPlusPen
				.endif
				;-------------------------------------------------------
;				.if _hGdiPlusPen == NULL
;					invoke MakeARGB,@alpha,@red,@green,@blue
;					invoke GdipCreatePen1,eax,1,UnitPixel,addr _hGdiPlusPen
;				.endif
				;-------------------------------------------------------
				.while TRUE
					mov eax,@x1
					.break .if eax == @rect.right
					mov eax,@x2
					.break .if eax == @rect.left
					mov eax,@y1
					.break .if eax == @rect.bottom
					mov eax,@y2
					.break .if eax == @rect.top
					invoke GdipDrawLineI,_hGdiPlusGraphics,_hGdiPlusPen,@x1,@y1,@x2,@y2
					inc @x1
					inc @y1
					dec @x2
					dec @y2
					invoke InvalidateRect,hWnd,NULL,FALSE
				.endw
				invoke ReleaseDC,hWnd,@hdc
				
			.elseif eax == IDM_drawrectangle
				.if _hGdiPlusPen != NULL
					invoke GdipDeletePen,_hGdiPlusPen
					mov _hGdiPlusPen,NULL
				.endif
				mov @alpha,128
				mov @red,0FFh
				mov @green,0h
				mov @blue,0h
				invoke MakeARGB,@alpha,@red,@green,@blue
				invoke GdipCreatePen1,eax,1,UnitPixel,addr _hGdiPlusPen
				invoke GdipDrawRectangleI,_hGdiPlusGraphics,_hGdiPlusPen,10,20,100,50
				
				lea eax,@rectfs
				mov esi,eax
				
				FLD4 20.0
				FSTP @rectf1.X
				FLD4 20.0
				FSTP @rectf1.Y
				FLD4 100.0
				FSTP @rectf1.W
				FLD4 20.0
				FSTP @rectf1.H
				
				FLD4 30.0
				FSTP @rectf2.X
				FLD4 30.0
				FSTP @rectf2.Y
				FLD4 150.0
				FSTP @rectf2.W
				FLD4 50.0
				FSTP @rectf2.H
				
				lea eax,@rectfs
				mov esi,eax
				lea eax,@rectf1
				mov [esi],eax
				lea eax,@rectf2
				mov [esi+4],eax
				invoke GdipDrawRectangles,_hGdiPlusGraphics,_hGdiPlusPen,esi,2
				
			.endif
		
		.endif
	.ELSE
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam		
		ret
	.ENDIF
	
	xor eax,eax
	ret
WndProc endp


end start
